/*******************************************************************************
 * Copyright 2009, 2010 Lars Grammel 
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *    http://www.apache.org/licenses/LICENSE-2.0 
 *     
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.  
 *******************************************************************************/
package org.thechiselgroup.choosel.protovis.client;

import com.google.gwt.core.client.JavaScriptObject;

/**
 * 
 * @author Lars Grammel
 */
public class PVColor extends JavaScriptObject {

    protected PVColor() {
    }

    // not part of pv.Color, but exists in both pv.Color.Hsl and Rgb
    public final native PVColor alpha(double alpha) /*-{
        return this.alpha(alpha);
    }-*/;

    public final native PVColor brighter() /*-{
        return this.brighter();
    }-*/;

    public final native PVColor brighter(double k) /*-{
        return this.brighter(k);
    }-*/;

    public final native PVColor darker() /*-{
        return this.darker();
    }-*/;

    public final native PVColor darker(double k) /*-{
        return this.darker(k);
    }-*/;

}