/*******************************************************************************
 * Copyright 2009, 2010 Lars Grammel 
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *    http://www.apache.org/licenses/LICENSE-2.0 
 *     
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.  
 *******************************************************************************/
package org.thechiselgroup.choosel.protovis.client;

import com.google.gwt.user.client.Element;

/**
 * 
 * @author Bradley Blashko
 * @author Lars Grammel
 */
public final class PVPanel extends PVAbstractPanel<PVPanel> {

    public final static class Type extends PVMarkType<PVPanel> {

        protected Type() {
        }

    }

    public static native PVPanel create() /*-{
        return new $wnd.pv.Panel();
    }-*/;

    /**
     * Creates a {@link PVPanel} that renders the visualization on
     * <code>element</code>.
     */
    public static PVPanel create(Element element) {
        return create().canvas(element);
    }

    protected PVPanel() {
    }

}